import axios, { AxiosRequestConfig, Method } from 'axios';
import jwt_decode from 'jwt-decode';
import { store } from '../store';

export const request = (
  method: Method,
  url: string,
  data: {} | null = null,
  headers: {} | null = null
) => {
  const API = axios.create({ baseURL: process.env.REACT_APP_BASE_URL });

  API.interceptors.request.use(
    async config => {
      const {} = store.getState();

      if (store.getState()) {
        const { exp }: { exp: number } = jwt_decode('');

        if (exp * 1000 < Date.now()) {
          try {

          } catch (err) {
            return err;
          }

          if (config.headers) config.headers.authorization = `Bearer `;
        }
      }

      return config;
    },
    error => {
      return error;
    },
  );

  return API.request({ method, url, data, headers } as AxiosRequestConfig);
};
